3 # $Id: configure,v 1.53 2016/10/20 18:47:49 schwarze Exp $
5 # Copyright (c) 2014, 2015, 2016 Ingo Schwarze <schwarze@openbsd.org>
7 # Permission to use, copy, modify, and distribute this software for any
8 # purpose with or without fee is hereby granted, provided that the above
9 # copyright notice and this permission notice appear in all copies.
11 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
21 [ -w config.log
] && mv config.log config.log.old
22 [ -w config.h
] && mv config.h config.h.old
24 # Output file descriptor usage:
25 # 1 (stdout): config.h, Makefile.local
26 # 2 (stderr): original stderr, usually to the console
30 echo "config.log: writing..."
32 # --- default settings -------------------------------------------------
33 # Initialize all variables here,
34 # such that nothing can leak in from the environment.
36 MANPATH_DEFAULT
="/usr/share/man:/usr/X11R6/man:/usr/local/man"
40 CC
=`printf "all:\\n\\t@echo \\\$(CC)\\n" | env -i make -sf -`
41 CFLAGS
="-g -W -Wall -Wmissing-prototypes -Wstrict-prototypes -Wwrite-strings"
42 CFLAGS
="${CFLAGS} -Wno-unused-parameter"
56 HAVE_FTS_COMPARE_CONST
=
94 BINM_APROPOS
="apropos"
95 BINM_MAKEWHATIS
="makewhatis"
100 MANM_MANCONF
="man.conf"
112 # --- manual settings from configure.local -----------------------------
114 if [ -r .
/configure.
local ]; then
115 echo "configure.local: reading..." 1>&2
116 echo "configure.local: reading..." 1>&3
117 cat .
/configure.
local 1>&3
120 echo "configure.local: no (fully automatic configuration)" 1>&2
121 echo "configure.local: no (fully automatic configuration)" 1>&3
125 # --- tests for config.h ----------------------------------------------
127 COMP
="${CC} ${CFLAGS} -Wno-unused -Werror"
129 # Check whether this HAVE_ setting is manually overridden.
130 # If yes, use the override, if no, do not decide anything yet.
131 # Arguments: lower-case test name, manual value
133 [ -z "${3}" ] && return 1
134 echo "${1}: manual (HAVE_${2}=${3})" 1>&2
135 echo "${1}: manual (HAVE_${2}=${3})" 1>&3
140 # Run a single autoconfiguration test.
141 # In case of success, enable the feature.
142 # In case of failure, do not decide anything yet.
143 # Arguments: lower-case test name, upper-case test name, additional CFLAGS
145 cat 1>&3 << __HEREDOC__
147 ${COMP} ${3} -o test-${1} test-${1}.c
150 if ${COMP} ${3} -o "test-${1}" "test-${1}.c" 1>&3 2>&3; then
151 echo "${1}${3}: ${CC} succeeded" 1>&3
153 echo "${1}${3}: ${CC} failed with $?" 1>&3
158 if .
/test-${1} 1>&3 2>&3; then
159 echo "${1}${3}: yes" 1>&2
160 echo "${1}${3}: yes" 1>&3
166 echo "${1}${3}: execution failed with $?" 1>&3
173 # Run a complete autoconfiguration test, including the check for
174 # a manual override and disabling the feature on failure.
175 # Arguments: lower case name, upper case name, additional CFLAGS
177 eval _manual
=\
${HAVE_${2}}
178 ismanual
"${1}" "${2}" "${_manual}" && return 0
179 singletest
"${1}" "${2}" "${3}" && return 0
180 echo "${1}${3}: no" 1>&2
185 # Select a UTF-8 locale.
187 [ -n "${HAVE_WCHAR}" ] && [ "${HAVE_WCHAR}" -eq 0 ] && return 0
188 ismanual UTF8_LOCALE UTF8_LOCALE
"$UTF8_LOCALE" && return 0
189 echo "UTF8_LOCALE: testing..." 1>&3
190 UTF8_LOCALE
=`locale -a | grep -i '^en_US\.UTF-*8$' | head -n 1`
191 if [ -z "${UTF8_LOCALE}" ]; then
192 UTF8_LOCALE
=`locale -a | grep -i '\.UTF-*8' | head -n 1`
193 [ -n "${UTF8_LOCALE}" ] || return 1
195 echo "UTF8_LOCALE=${UTF8_LOCALE}" 1>&2
196 echo "UTF8_LOCALE=${UTF8_LOCALE}" 1>&3
202 # --- library functions ---
203 runtest dirent
-namlen DIRENT_NAMLEN
|| true
204 runtest be32toh ENDIAN
|| true
205 runtest be32toh SYS_ENDIAN
-DSYS_ENDIAN || true
206 runtest EFTYPE EFTYPE
|| true
207 runtest err ERR
|| true
208 runtest getline GETLINE
|| true
209 runtest getsubopt GETSUBOPT
|| true
210 runtest isblank ISBLANK
|| true
211 runtest mkdtemp MKDTEMP
|| true
212 runtest ntohl NTOHL
|| true
213 runtest PATH_MAX PATH_MAX
|| true
214 runtest pledge PLEDGE
|| true
215 runtest sandbox_init SANDBOX_INIT
|| true
216 runtest progname PROGNAME
|| true
217 runtest reallocarray REALLOCARRAY
|| true
218 runtest rewb
-bsd REWB_BSD
|| true
219 runtest rewb
-sysv REWB_SYSV
|| true
220 runtest strcasestr STRCASESTR
|| true
221 runtest stringlist STRINGLIST
|| true
222 runtest strlcat STRLCAT
|| true
223 runtest strlcpy STRLCPY
|| true
224 runtest strptime STRPTIME
|| true
225 runtest strsep STRSEP
|| true
226 runtest strtonum STRTONUM
|| true
227 runtest vasprintf VASPRINTF
|| true
229 if [ ${HAVE_ENDIAN} -eq 0 -a \
230 ${HAVE_SYS_ENDIAN} -eq 0 -a \
231 ${HAVE_NTOHL} -eq 0 ]; then
232 echo "FATAL: no endian conversion functions found" 1>&2
233 echo "FATAL: no endian conversion functions found" 1>&3
237 if ismanual fts FTS
${HAVE_FTS}; then
238 HAVE_FTS_COMPARE_CONST
=0
239 elif runtest fts FTS_COMPARE_CONST
-DFTS_COMPARE_CONST; then
242 runtest fts FTS
|| true
245 # --- wide character and locale support ---
247 runtest wchar WCHAR
-DUTF8_LOCALE=\"${UTF8_LOCALE}\" || true
250 echo "wchar: no (no UTF8_LOCALE)" 1>&2
251 echo "wchar: no (no UTF8_LOCALE)" 1>&3
255 if [ -n "${LD_NANOSLEEP}" ]; then
256 runtest nanosleep NANOSLEEP
"${LD_NANOSLEEP}" || true
257 elif singletest nanosleep NANOSLEEP
; then
259 elif runtest nanosleep NANOSLEEP
"-lrt"; then
262 if [ "${HAVE_NANOSLEEP}" -eq 0 ]; then
263 echo "FATAL: nanosleep: no" 1>&2
264 echo "FATAL: nanosleep: no" 1>&3
269 if ismanual ohash OHASH
"${HAVE_OHASH}"; then
271 elif [ -n "${LD_OHASH}" ]; then
272 runtest ohash OHASH
"${LD_OHASH}" || true
273 elif singletest ohash OHASH
; then
275 elif runtest ohash OHASH
"-lutil"; then
278 if [ "${HAVE_OHASH}" -eq 0 ]; then
283 LDADD
="${LDADD} ${LD_NANOSLEEP} ${LD_OHASH} -lz"
284 echo "LDADD=\"${LDADD}\"" 1>&2
285 echo "LDADD=\"${LDADD}\"" 1>&3
288 # --- write config.h ---
294 #error "Do not use C++. See the INSTALL file."
297 #if !defined(__GNUC__) || (__GNUC__ < 4)
298 #define __attribute__(x)
301 #if defined(__linux__) || defined(__MINT__)
302 #define _GNU_SOURCE /* See test-*.c what needs this. */
307 [ ${HAVE_GETLINE} -eq 0 -o ${HAVE_REALLOCARRAY} -eq 0 -o \
308 ${HAVE_STRLCAT} -eq 0 -o ${HAVE_STRLCPY} -eq 0 ] \
309 && echo "#include <sys/types.h>"
310 [ ${HAVE_VASPRINTF} -eq 0 ] && echo "#include <stdarg.h>"
311 [ ${HAVE_GETLINE} -eq 0 ] && echo "#include <stdio.h>"
314 echo "#define MAN_CONF_FILE \"/etc/${MANM_MANCONF}\""
315 echo "#define MANPATH_DEFAULT \"${MANPATH_DEFAULT}\""
316 [ -n "${OSNAME}" ] && echo "#define OSNAME \"${OSNAME}\""
317 [ -n "${UTF8_LOCALE}" ] && echo "#define UTF8_LOCALE \"${UTF8_LOCALE}\""
318 [ -n "${HOMEBREWDIR}" ] && echo "#define HOMEBREWDIR \"${HOMEBREWDIR}\""
319 [ ${HAVE_EFTYPE} -eq 0 ] && echo "#define EFTYPE EINVAL"
320 [ ${HAVE_PATH_MAX} -eq 0 ] && echo "#define PATH_MAX 4096"
321 if [ ${HAVE_ENDIAN} -eq 0 -a ${HAVE_SYS_ENDIAN} -eq 0 ]; then
322 echo "#define be32toh ntohl"
323 echo "#define htobe32 htonl"
327 #define HAVE_DIRENT_NAMLEN ${HAVE_DIRENT_NAMLEN}
328 #define HAVE_ENDIAN ${HAVE_ENDIAN}
329 #define HAVE_ERR ${HAVE_ERR}
330 #define HAVE_FTS ${HAVE_FTS}
331 #define HAVE_FTS_COMPARE_CONST ${HAVE_FTS_COMPARE_CONST}
332 #define HAVE_GETLINE ${HAVE_GETLINE}
333 #define HAVE_GETSUBOPT ${HAVE_GETSUBOPT}
334 #define HAVE_ISBLANK ${HAVE_ISBLANK}
335 #define HAVE_MKDTEMP ${HAVE_MKDTEMP}
336 #define HAVE_NTOHL ${HAVE_NTOHL}
337 #define HAVE_PLEDGE ${HAVE_PLEDGE}
338 #define HAVE_PROGNAME ${HAVE_PROGNAME}
339 #define HAVE_REALLOCARRAY ${HAVE_REALLOCARRAY}
340 #define HAVE_REWB_BSD ${HAVE_REWB_BSD}
341 #define HAVE_REWB_SYSV ${HAVE_REWB_SYSV}
342 #define HAVE_SANDBOX_INIT ${HAVE_SANDBOX_INIT}
343 #define HAVE_STRCASESTR ${HAVE_STRCASESTR}
344 #define HAVE_STRINGLIST ${HAVE_STRINGLIST}
345 #define HAVE_STRLCAT ${HAVE_STRLCAT}
346 #define HAVE_STRLCPY ${HAVE_STRLCPY}
347 #define HAVE_STRPTIME ${HAVE_STRPTIME}
348 #define HAVE_STRSEP ${HAVE_STRSEP}
349 #define HAVE_STRTONUM ${HAVE_STRTONUM}
350 #define HAVE_SYS_ENDIAN ${HAVE_SYS_ENDIAN}
351 #define HAVE_VASPRINTF ${HAVE_VASPRINTF}
352 #define HAVE_WCHAR ${HAVE_WCHAR}
353 #define HAVE_OHASH ${HAVE_OHASH}
355 #define BINM_APROPOS "${BINM_APROPOS}"
356 #define BINM_MAKEWHATIS "${BINM_MAKEWHATIS}"
357 #define BINM_MAN "${BINM_MAN}"
358 #define BINM_SOELIM "${BINM_SOELIM}"
359 #define BINM_WHATIS "${BINM_WHATIS}"
363 if [ ${HAVE_ERR} -eq 0 ]; then
364 echo "extern void err(int, const char *, ...);"
365 echo "extern void errx(int, const char *, ...);"
366 echo "extern void warn(const char *, ...);"
367 echo "extern void warnx(const char *, ...);"
370 [ ${HAVE_GETLINE} -eq 0 ] && \
371 echo "extern ssize_t getline(char **, size_t *, FILE *);"
373 [ ${HAVE_GETSUBOPT} -eq 0 ] && \
374 echo "extern int getsubopt(char **, char * const *, char **);"
376 [ ${HAVE_ISBLANK} -eq 0 ] && \
377 echo "extern int isblank(int);"
379 [ ${HAVE_MKDTEMP} -eq 0 ] && \
380 echo "extern char *mkdtemp(char *);"
382 if [ ${HAVE_PROGNAME} -eq 0 ]; then
383 echo "extern const char *getprogname(void);"
384 echo "extern void setprogname(const char *);"
387 [ ${HAVE_REALLOCARRAY} -eq 0 ] && \
388 echo "extern void *reallocarray(void *, size_t, size_t);"
390 [ ${HAVE_STRCASESTR} -eq 0 ] && \
391 echo "extern char *strcasestr(const char *, const char *);"
393 [ ${HAVE_STRLCAT} -eq 0 ] && \
394 echo "extern size_t strlcat(char *, const char *, size_t);"
396 [ ${HAVE_STRLCPY} -eq 0 ] && \
397 echo "extern size_t strlcpy(char *, const char *, size_t);"
399 [ ${HAVE_STRSEP} -eq 0 ] && \
400 echo "extern char *strsep(char **, const char *);"
402 [ ${HAVE_STRTONUM} -eq 0 ] && \
403 echo "extern long long strtonum(const char *, long long, long long, const char **);"
405 [ ${HAVE_VASPRINTF} -eq 0 ] && \
406 echo "extern int vasprintf(char **, const char *, va_list);"
408 echo "config.h: written" 1>&2
409 echo "config.h: written" 1>&3
411 # --- tests for Makefile.local -----------------------------------------
413 exec > Makefile.
local
415 [ -z "${BINDIR}" ] && BINDIR
="${PREFIX}/bin"
416 [ -z "${SBINDIR}" ] && SBINDIR
="${PREFIX}/sbin"
417 [ -z "${INCLUDEDIR}" ] && INCLUDEDIR
="${PREFIX}/include/mandoc"
418 [ -z "${LIBDIR}" ] && LIBDIR
="${PREFIX}/lib/mandoc"
419 [ -z "${MANDIR}" ] && MANDIR
="${PREFIX}/man"
421 [ -z "${HTDOCDIR}" ] && HTDOCDIR
="${WWWPREFIX}/htdocs"
422 [ -z "${CGIBINDIR}" ] && CGIBINDIR
="${WWWPREFIX}/cgi-bin"
424 [ -z "${INSTALL_PROGRAM}" ] && INSTALL_PROGRAM
="${INSTALL} -m 0555"
425 [ -z "${INSTALL_LIB}" ] && INSTALL_LIB
="${INSTALL} -m 0444"
426 [ -z "${INSTALL_MAN}" ] && INSTALL_MAN
="${INSTALL} -m 0444"
427 [ -z "${INSTALL_DATA}" ] && INSTALL_DATA
="${INSTALL} -m 0444"
430 [ ${BUILD_CGI} -gt 0 ] && BUILD_TARGETS
="cgi-build"
432 [ ${BUILD_CGI} -gt 0 ] && INSTALL_TARGETS
="cgi-install"
435 BUILD_TARGETS = ${BUILD_TARGETS}
436 INSTALL_TARGETS = ${INSTALL_TARGETS}
445 INCLUDEDIR = ${INCLUDEDIR}
448 WWWPREFIX = ${WWWPREFIX}
449 HTDOCDIR = ${HTDOCDIR}
450 CGIBINDIR = ${CGIBINDIR}
451 BINM_APROPOS = ${BINM_APROPOS}
452 BINM_MAKEWHATIS = ${BINM_MAKEWHATIS}
453 BINM_MAN = ${BINM_MAN}
454 BINM_SOELIM = ${BINM_SOELIM}
455 BINM_WHATIS = ${BINM_WHATIS}
456 MANM_MAN = ${MANM_MAN}
457 MANM_MANCONF = ${MANM_MANCONF}
458 MANM_MDOC = ${MANM_MDOC}
459 MANM_ROFF = ${MANM_ROFF}
460 MANM_EQN = ${MANM_EQN}
461 MANM_TBL = ${MANM_TBL}
463 INSTALL_PROGRAM = ${INSTALL_PROGRAM}
464 INSTALL_LIB = ${INSTALL_LIB}
465 INSTALL_MAN = ${INSTALL_MAN}
466 INSTALL_DATA = ${INSTALL_DATA}
469 echo "Makefile.local: written" 1>&2
470 echo "Makefile.local: written" 1>&3